libzmf Namespace Reference documentation

Classes | Typedefs | Enumerations | Functions
libzmf Namespace Reference

## Classes
struct | Arrow
class | BMIHeader
struct | BMIOffset
class | BMIParser
struct | BoundingBox
struct | Cell
struct | Color
struct | ColorBitmap
struct | Column
struct | Curve
struct | EndOfStreamException
struct | Font
struct | GenericException
struct | Gradient
struct | GradientStop
struct | Image
struct | ImageFill
struct | Paragraph
struct | ParagraphStyle
struct | Pen
struct | Point
struct | Row
struct | Shadow
struct | Span
struct | Style
struct | Table
struct | Text
struct | Transparency
class | ZBRHeader
class | ZBRParser
class | ZMF2Header
class | ZMF2Parser
class | ZMF4Header
class | ZMF4Parser
class | ZMFCollector
struct | ZMFDummyDeleter
struct | ZMFPageSettings

## Typedefs
typedef std::shared_ptr< librevenge::RVNGInputStream > | RVNGInputStreamPtr
typedef std::shared_ptr< Arrow > | ArrowPtr
typedef boost::variant< Color, Gradient, ImageFill > | Fill

## Enumerations
enum | BMIStreamType { BMIStreamType::UNKNOWN, BMIStreamType::BITMAP, BMIStreamType::END_OF_FILE }
enum | CurveType { CurveType::LINE, CurveType::BEZIER_CURVE }
enum | LineCapType { LineCapType::BUTT, LineCapType::FLAT, LineCapType::ROUND, LineCapType::POINTED }
enum | LineJoinType { LineJoinType::MITER, LineJoinType::ROUND, LineJoinType::BEVEL }
enum | GradientType { GradientType::LINEAR, GradientType::RADIAL, GradientType::CONICAL, GradientType::CROSS, GradientType::RECTANGULAR, GradientType::FLEXIBLE }
enum | HorizontalAlignment { HorizontalAlignment::LEFT, HorizontalAlignment::RIGHT, HorizontalAlignment::BLOCK, HorizontalAlignment::CENTER, HorizontalAlignment::FULL }
enum | VerticalAlignment { VerticalAlignment::TOP, VerticalAlignment::MIDDLE, VerticalAlignment::BOTTOM }

## Functions
bool | operator== (const BMIOffset &lhs, const BMIOffset &rhs)
bool | operator!= (const BMIOffset &lhs, const BMIOffset &rhs)
uint8_t | readU8 (const RVNGInputStreamPtr &input, bool)
uint16_t | readU16 (const RVNGInputStreamPtr &input, bool bigEndian)
uint32_t | readU32 (const RVNGInputStreamPtr &input, bool bigEndian)
uint64_t | readU64 (const RVNGInputStreamPtr &input, bool bigEndian)
int32_t | readS32 (const RVNGInputStreamPtr &input, bool bigEndian)
float | readFloat (const RVNGInputStreamPtr &input, bool bigEndian)
const unsigned char * | readNBytes (const RVNGInputStreamPtr &input, const unsigned long numBytes)
void | skip (const RVNGInputStreamPtr &input, unsigned long numBytes)
void | seek (const RVNGInputStreamPtr &input, const unsigned long pos)
void | seekRelative (const RVNGInputStreamPtr &input, const long pos)
unsigned long | getLength (const RVNGInputStreamPtr &input)
void | appendCharacters (librevenge::RVNGString &text, const unsigned char *characters, uint32_t size, const char *encoding)
void | writeU16 (librevenge::RVNGBinaryData &buffer, const int value)
void | writeU32 (librevenge::RVNGBinaryData &buffer, const int value)
double | rad2deg (double value)
double | normalizeAngle (double radAngle)
template<typename T >
std::string | prettyTypeName ()
template<std::size_t numBytes>
std::bitset< numBytes *8 > | bytesToBitset (const uint8_t *data)
template<typename T >
double | um2in (T micrometers)
bool | operator== (const Point &lhs, const Point &rhs)
bool | operator!= (const Point &lhs, const Point &rhs)

## Typedef Documentation

## ◆ ArrowPtr

typedef std::shared_ptr<Arrow> libzmf::ArrowPtr

## ◆ Fill

typedef boost::variant<Color, Gradient, ImageFill> libzmf::Fill

## ◆ RVNGInputStreamPtr

typedef std::shared_ptr<librevenge::RVNGInputStream> libzmf::RVNGInputStreamPtr

## Enumeration Type Documentation

## ◆ BMIStreamType

enum libzmf::BMIStreamType
| strong

Enumerator
UNKNOWN |
BITMAP |
END_OF_FILE |

## ◆ CurveType

enum libzmf::CurveType
| strong

Enumerator
LINE |
BEZIER_CURVE |

## ◆ GradientType

enum libzmf::GradientType
| strong

Enumerator
LINEAR |
RADIAL |
CONICAL |
CROSS |
RECTANGULAR |
FLEXIBLE |

## ◆ HorizontalAlignment

enum libzmf::HorizontalAlignment
| strong

Enumerator
LEFT |
RIGHT |
BLOCK |
CENTER |
FULL |

## ◆ LineCapType

enum libzmf::LineCapType
| strong

Enumerator
BUTT |
FLAT |
ROUND |
POINTED |

## ◆ LineJoinType

enum libzmf::LineJoinType
| strong

Enumerator
MITER |
ROUND |
BEVEL |

## ◆ VerticalAlignment

enum libzmf::VerticalAlignment
| strong

Enumerator
TOP |
MIDDLE |
BOTTOM |

## Function Documentation

## ◆ appendCharacters()

void libzmf::appendCharacters | ( | librevenge::RVNGString & | text,
|  | const unsigned char * | characters,
|  | uint32_t | size,
|  | const char * | encoding
| ) |  |

Referenced by libzmf::ZMF4Parser::readText().

## ◆ bytesToBitset()

template<std::size_t numBytes>

std::bitset<numBytes * 8> libzmf::bytesToBitset | ( | const uint8_t * | data | ) |

## ◆ getLength()

unsigned long libzmf::getLength | ( | const RVNGInputStreamPtr & | input | ) |

Referenced by libzmf::ZMF4Parser::parse().

## ◆ normalizeAngle()

double libzmf::normalizeAngle | ( | double | radAngle | ) |

Referenced by rad2deg().

## ◆ operator!=() [1/2]

bool libzmf::operator!= | ( | const BMIOffset & | lhs,
|  | const BMIOffset & | rhs
| ) |  |

## ◆ operator!=() [2/2]

bool libzmf::operator!= | ( | const Point & | lhs,
|  | const Point & | rhs
| ) |  |

## ◆ operator==() [1/2]

bool libzmf::operator== | ( | const BMIOffset & | lhs,
|  | const BMIOffset & | rhs
| ) |  |

## ◆ operator==() [2/2]

bool libzmf::operator== | ( | const Point & | lhs,
|  | const Point & | rhs
| ) |  |

## ◆ prettyTypeName()

template<typename T >

std::string libzmf::prettyTypeName | ( |  | ) |

## ◆ rad2deg()

double libzmf::rad2deg | ( | double | value | ) |

Referenced by libzmf::ZMFCollector::collectEllipse(), libzmf::ZMFCollector::collectImage(), and libzmf::ZMFCollector::collectTextObject().

## ◆ readFloat()

float libzmf::readFloat | ( | const RVNGInputStreamPtr & | input,
|  | bool | bigEndian
| ) |  |

Referenced by libzmf::ZMF4Parser::readArrow(), libzmf::ZMF4Parser::readEllipse(), libzmf::ZMF4Parser::readFont(), libzmf::ZMF4Parser::readGradient(), libzmf::ZMF4Parser::readParagraphStyle(), libzmf::ZMF4Parser::readShadow(), libzmf::ZMF4Parser::readTable(), and libzmf::ZMF4Parser::readUnscaledPoint().

## ◆ readNBytes()

const unsigned char * libzmf::readNBytes | ( | const RVNGInputStreamPtr & | input,
|  | const unsigned long | numBytes
| ) |  |

Referenced by libzmf::BMIHeader::load(), libzmf::BMIParser::readData(), libzmf::ZMF4Parser::readFont(), libzmf::ZMF4Parser::readPen(), and libzmf::ZMF4Parser::readText().

## ◆ readS32()

int32_t libzmf::readS32 | ( | const RVNGInputStreamPtr & | input,
|  | bool | bigEndian
| ) |  |

Referenced by libzmf::ZMF4Parser::readPoint().

## ◆ readU16()

uint16_t libzmf::readU16 | ( | const RVNGInputStreamPtr & | input,
|  | bool | bigEndian
| ) |  |

Referenced by libzmf::ZBRHeader::load(), libzmf::BMIHeader::load(), libzmf::BMIParser::ColorBitmapHeader::parse(), libzmf::BMIParser::readData(), libzmf::BMIHeader::readOffsets(), and libzmf::ZMF4Parser::readPen().

## ◆ readU32()

uint32_t libzmf::readU32 | ( | const RVNGInputStreamPtr & | input,
|  | bool | bigEndian
| ) |  |

Referenced by libzmf::ZMF4Header::load(), libzmf::ZMF4Parser::readBitmap(), libzmf::ZMF4Parser::readCurveComponents(), libzmf::ZMF4Parser::readCurveSectionTypes(), libzmf::ZMF4Parser::readDocumentSettings(), libzmf::ZMF4Parser::readFill(), readFloat(), libzmf::ZMF4Parser::readGradient(), libzmf::ZMF4Parser::readObjectHeader(), libzmf::ZMF4Parser::readObjectRefs(), libzmf::BMIHeader::readOffsets(), libzmf::ZMF4Parser::readPen(), libzmf::ZMF4Parser::readPolygon(), libzmf::ZMF4Parser::readPreviewBitmap(), readS32(), libzmf::ZMF4Parser::readShadow(), libzmf::ZMF4Parser::readTable(), libzmf::ZMF4Parser::readText(), and libzmf::ZMF4Parser::readTransparency().

## ◆ readU64()

uint64_t libzmf::readU64 | ( | const RVNGInputStreamPtr & | input,
|  | bool | bigEndian
| ) |  |

## ◆ readU8()

uint8_t libzmf::readU8 | ( | const RVNGInputStreamPtr & | input,
|  | bool |
| ) |  |

Referenced by getLength(), libzmf::ZMF4Parser::readColor(), libzmf::BMIParser::readColorPalette(), libzmf::ZMF4Parser::readEllipse(), libzmf::ZMF4Parser::readFont(), libzmf::ZMF4Parser::readObjectHeader(), libzmf::ZMF4Parser::readParagraphStyle(), and libzmf::ZMF4Parser::readTextFrame().

## ◆ seek()

void libzmf::seek | ( | const RVNGInputStreamPtr & | input,
|  | const unsigned long | pos
| ) |  |

Referenced by getLength(), libzmf::ZMF4Header::load(), libzmf::ZMF4Parser::parse(), libzmf::BMIParser::ColorBitmapHeader::parse(), libzmf::ZMF4Parser::readBitmap(), libzmf::BMIParser::readColorBitmap(), libzmf::ZMF4Parser::readDocumentSettings(), libzmf::ZMF4Parser::readLayer(), libzmf::ZMF4Parser::readObjectRefs(), and libzmf::ZMF4Parser::readPage().

## ◆ seekRelative()

void libzmf::seekRelative | ( | const RVNGInputStreamPtr & | input,
|  | const long | pos
| ) |  |

Referenced by skip().

## ◆ skip()

void libzmf::skip | ( | const RVNGInputStreamPtr & | input,
|  | unsigned long | numBytes
| ) |  |

Referenced by libzmf::ZBRHeader::load(), libzmf::BMIHeader::load(), libzmf::ZMF4Parser::readArrow(), libzmf::ZMF4Parser::readBitmap(), libzmf::ZMF4Parser::readBoundingBox(), libzmf::BMIParser::readColorPalette(), libzmf::ZMF4Parser::readCurve(), libzmf::ZMF4Parser::readCurveComponents(), libzmf::ZMF4Parser::readCurveSectionTypes(), libzmf::BMIParser::readData(), libzmf::ZMF4Parser::readDocumentSettings(), libzmf::ZMF4Parser::readFill(), libzmf::ZMF4Parser::readFont(), libzmf::ZMF4Parser::readGradient(), libzmf::ZMF4Parser::readObjectHeader(), libzmf::ZMF4Parser::readParagraphStyle(), libzmf::ZMF4Parser::readPen(), libzmf::ZMF4Parser::readPolygon(), libzmf::ZMF4Parser::readPreviewBitmap(), libzmf::ZMF4Parser::readShadow(), libzmf::ZMF4Parser::readTable(), libzmf::ZMF4Parser::readText(), and libzmf::ZMF4Parser::readTransparency().

## ◆ um2in()

template<typename T >

double libzmf::um2in | ( | T | micrometers | ) |

Referenced by libzmf::ZMF4Parser::readDocumentSettings(), libzmf::ZMF4Parser::readFill(), libzmf::ZMF4Parser::readPen(), and libzmf::ZMF4Parser::readPoint().

## ◆ writeU16()

void libzmf::writeU16 | ( | librevenge::RVNGBinaryData & | buffer,
|  | const int | value
| ) |  |

## ◆ writeU32()

void libzmf::writeU32 | ( | librevenge::RVNGBinaryData & | buffer,
|  | const int | value
| ) |  |